package org.jvnet.jaxbcommons.enums.addon.generator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;

import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JOp;
import com.sun.codemodel.JVar;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class CodesStrategy extends AbstractMethodStrategy {

  private final Map processedClassesMap = new HashMap();

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {

    if (processedClassesMap.keySet().contains(theClass)) {
      return (JMethod) processedClassesMap.get(theClass);

    }
    else {
      final JCodeModel codeModel = getCodeModel(classContext);

      final JVar $codes = theClass.field(JMod.PRIVATE + JMod.STATIC, List.class, "codes");

      final JMethod constructor = (JMethod) theClass.constructors().next();
      constructor.body()._if(JOp.eq($codes, JExpr._null()))._then().assign(
          $codes,
          JExpr._new(codeModel.ref(ArrayList.class)));

      constructor.body().invoke($codes, "add").arg(JExpr.ref("v"));

      final JMethod values = theClass.method(JMod.PUBLIC | JMod.STATIC, codeModel
          .ref(String.class)
          .array(), "codes");
      values.body()._return(
          JExpr.cast(codeModel.ref(String.class).array(), $codes.invoke("toArray").arg(
              JExpr.newArray(codeModel.ref(String.class), JExpr.invoke($codes, "size")))));
      processedClassesMap.put(theClass, values);
      return values;
    }
  }
}
