package org.jvnet.jaxbcommons.tree.addon.generator;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;
import org.jvnet.jaxbcommons.tree.Node;

import com.sun.codemodel.JClass;
import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JStatement;
import com.sun.codemodel.JType;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class CreateFieldNodeStrategy extends AbstractMethodStrategy {

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {

    final JCodeModel codeModel = getCodeModel(classContext);

    final JClass nodeClass = codeModel.ref(Node.class);

    final JType nodeArrayType = nodeClass.array();

    final String methodName = "create" + fieldItem.name + "Nodes";

    final JMethod createNode = theClass.method(JMod.PUBLIC, nodeArrayType, methodName);

    final JStatement statement = (JStatement) fieldItem.visit(new CreateFieldNodeVisitor(classContext));

    if (statement != null) {
      createNode.body().add(statement);
    }
    else {
      createNode.body()._return(JExpr.newArray(nodeClass, 0));
    }
    return createNode;
  }
}
