package org.jvnet.jaxbcommons.tree.addon.generator;

import org.jvnet.jaxbcommons.tree.Node;
import org.jvnet.jaxbcommons.tree.util.NodeUtils;
import org.jvnet.jaxbcommons.util.AccessorUtils;
import org.jvnet.jaxbcommons.util.TypeUtils;
import org.jvnet.jaxbcommons.visitor.ClassifyingVisitor;

import com.sun.codemodel.JArray;
import com.sun.codemodel.JBlock;
import com.sun.codemodel.JConditional;
import com.sun.codemodel.JExpr;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;

public class CreateFieldNodeVisitor extends ClassifyingVisitor {

  public CreateFieldNodeVisitor(ClassContext classContext) {
    super(classContext);
  }

  public Object onComplexSingleField(FieldItem fieldItem) {
    final ClassItem fieldClassItem = (ClassItem) TypeUtils.getCommonBaseTypeItem(
        classContext,
        fieldItem);
    final JBlock block = JBlock.dummyInstance.block();

    final JArray nodes = JExpr.newArray(codeModel.ref(Node.class));
    nodes.add(JExpr.invoke(AccessorUtils.get(classContext, fieldItem)).invoke("createNode").arg(
        JExpr.lit(fieldItem.name)));

    final JConditional ifSet = block
        ._if(JExpr.invoke(AccessorUtils.isSet(classContext, fieldItem)));

    ifSet._then()._return(nodes);
    ifSet._else()._return(JExpr.newArray(codeModel.ref(Node.class)));

    return block;
  }

  public Object onComplexCollectionField(FieldItem fieldItem) {
    final ClassItem fieldClassItem = (ClassItem) TypeUtils.getCommonBaseTypeItem(
        classContext,
        fieldItem);
    final ClassContext fieldClassContext = classContext.parent.getClassContext(fieldClassItem);
    final JBlock block = JBlock.dummyInstance.block();

    //    final JArray nodes = JExpr.newArray(codeModel.ref(Node.class));
    //    nodes.add(JExpr.invoke(AccessorUtils.get(classContext, fieldItem)).invoke("createNode").arg(
    //        JExpr.ref("name")));
    //
    final JConditional ifSet = block
        ._if(JExpr.invoke(AccessorUtils.isSet(classContext, fieldItem)));

    ifSet._then()._return(
        codeModel.ref(NodeUtils.class).staticInvoke("createNodes").arg(

        JExpr.lit(fieldItem.name)).arg(fieldClassContext.ref.staticRef("class")).arg(
            JExpr.invoke(AccessorUtils.get(classContext, fieldItem))));

    ifSet._else()._return(JExpr.newArray(codeModel.ref(Node.class)));

    return block;
  }
}
